Index: drivers/scsi/qla1280.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qla1280.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qla1280.c	22 Jul 2004 19:50:06 -0000	1.1
+++ drivers/scsi/qla1280.c	4 Aug 2004 01:29:36 -0000	1.2
@@ -2977,322 +2704,366 @@
  * Returns:
  *      0 = success.
  */
-STATIC uint8_t
-qla1280_nvram_config(scsi_qla_host_t *ha)
+static int
+qla1280_nvram_config(struct scsi_qla_host *ha)
 {
-    device_reg_t *reg   = ha->iobase;
-    nvram_t      *nv    = (nvram_t *)ha->response_ring; 
-    uint8_t      status = 0;
-    uint32_t     b, t, l;
-    uint16_t     *wptr;
-    uint16_t     mb[MAILBOX_REGISTER_COUNT];
-    uint8_t      cnt;
-    uint8_t      chksum;
-    uint32_t     nvsize;
-
-#if defined(QL_DEBUG_ROUTINES) && !defined(QL_DEBUG_LEVEL_4)
-    uint8_t      saved_print_status = ql_debug_print;
-#endif
-    ENTER("qla1280_nvram_config");
-#if defined(QL_DEBUG_ROUTINES) && !defined(QL_DEBUG_LEVEL_4)
-    ql_debug_print = FALSE;
-#endif
-
-    /* Verify valid NVRAM checksum. */
-#if  USE_NVRAM_DEFAULTS
-    chksum = 1;
-#else
-    wptr = (uint16_t *)ha->response_ring;
-    chksum = 0;
-    if( ha->device_id == QLA12160_DEVICE_ID ||  
-        ha->device_id == QLA10160_DEVICE_ID )  
-    nvsize = sizeof(nvram160_t)/2;
-    else
-    nvsize = sizeof(nvram_t)/2;
-    for( cnt = 0; cnt < nvsize; cnt++ ) 
-    {
-        *wptr = qla1280_get_nvram_word(ha, cnt); 
-        chksum += (uint8_t)*wptr;
-        chksum += (uint8_t)(*wptr >> 8);
-        wptr++;
-    }
-#endif
-
+	struct device_reg *reg = ha->iobase;
+	struct nvram *nv;
+	int is1x160, status = 0;
+	int bus, target, lun;
+	uint16_t mb[MAILBOX_REGISTER_COUNT];
+	uint16_t mask;
+
+	ENTER("qla1280_nvram_config");
+
+	if (ha->device_id == PCI_DEVICE_ID_QLOGIC_ISP12160 ||
+	    ha->device_id == PCI_DEVICE_ID_QLOGIC_ISP10160)
+		is1x160 = 1;
+	else
+		is1x160 = 0;
 
-    /* Bad NVRAM data, set defaults parameters. */
-    if (chksum || nv->id[0] != 'I' || nv->id[1] != 'S' ||
-        nv->id[2] != 'P' || nv->id[3] != ' ' || nv->version < 1)
-    {
-#if  USE_NVRAM_DEFAULTS
-        DEBUG(printk("Using defaults for NVRAM\n"));
+	nv = &ha->nvram;
+	if (!ha->nvram_valid) {
+		dprintk(1, "Using defaults for NVRAM: \n");
+		memset(nv, 0, sizeof(struct nvram));
+
+		/* nv->cntr_flags_1.disable_loading_risc_code = 1; */
+		nv->firmware_feature.f.enable_fast_posting = 1;
+		nv->firmware_feature.f.disable_synchronous_backoff = 1;
+
+		nv->termination.f.scsi_bus_0_control = 3;
+		nv->termination.f.scsi_bus_1_control = 3;
+		nv->termination.f.auto_term_support = 1;
+
+		/*
+		 * Set default FIFO magic - What appropriate values
+		 * would be here is unknown. This is what I have found
+		 * testing with 12160s.
+		 * Now, I would love the magic decoder ring for this one,
+		 * the header file provided by QLogic seems to be bogus
+		 * or incomplete at best.
+		 */
+		nv->isp_config.c = 0x44;
+
+		if (is1x160)
+			nv->isp_parameter = 0x01;
+
+		for (bus = 0; bus < MAX_BUSES; bus++) {
+			nv->bus[bus].config_1.initiator_id = 7;
+			nv->bus[bus].bus_reset_delay = 5;
+			/* 8 = 5.0 clocks */
+			nv->bus[bus].config_2.async_data_setup_time = 8;
+			nv->bus[bus].config_2.req_ack_active_negation = 1;
+			nv->bus[bus].config_2.data_line_active_negation = 1;
+			nv->bus[bus].selection_timeout = 250;
+			nv->bus[bus].max_queue_depth = 256;
+
+			for (target = 0; target < MAX_TARGETS; target++) {
+				nv->bus[bus].target[target].parameter.f.
+					renegotiate_on_error = 1;
+				nv->bus[bus].target[target].parameter.f.
+					auto_request_sense = 1;
+				nv->bus[bus].target[target].parameter.f.
+					tag_queuing = 1;
+				nv->bus[bus].target[target].parameter.f.
+					enable_sync = 1;
+#if 1	/* Some SCSI Processors do not seem to like this */
+				nv->bus[bus].target[target].parameter.f.
+					enable_wide = 1;
+#endif
+				nv->bus[bus].target[target].parameter.f.
+					parity_checking = 1;
+				nv->bus[bus].target[target].parameter.f.
+					disconnect_allowed = 1;
+				nv->bus[bus].target[target].execution_throttle=
+					nv->bus[bus].max_queue_depth - 1;
+				if (is1x160) {
+					nv->bus[bus].target[target].flags.
+						flags1x160.device_enable = 1;
+					nv->bus[bus].target[target].flags.
+						flags1x160.sync_offset = 0x0e;
+					nv->bus[bus].target[target].
+						sync_period = 9;
+					nv->bus[bus].target[target].
+						ppr_1x160.flags.enable_ppr = 1;
+					nv->bus[bus].target[target].ppr_1x160.
+						flags.ppr_options = 2;
+					nv->bus[bus].target[target].ppr_1x160.
+						flags.ppr_bus_width = 1;
+				} else {
+					nv->bus[bus].target[target].flags.
+						flags1x80.device_enable = 1;
+					nv->bus[bus].target[target].flags.
+						flags1x80.sync_offset = 0x8;
+					nv->bus[bus].target[target].
+						sync_period = 10;
+				}
+			}
+		}
+	} else {
+		/* Always force AUTO sense for LINUX SCSI */
+		for (bus = 0; bus < MAX_BUSES; bus++)
+			for (target = 0; target < MAX_TARGETS; target++) {
+				nv->bus[bus].target[target].parameter.f.
+					auto_request_sense = 1;
+			}
+	}
+	dprintk(1, "qla1280 : initiator scsi id bus[0]=%d\n",
+		nv->bus[0].config_1.initiator_id);
+	dprintk(1, "qla1280 : initiator scsi id bus[1]=%d\n",
+		nv->bus[1].config_1.initiator_id);
+
+	dprintk(1, "qla1280 : bus reset delay[0]=%d\n",
+		nv->bus[0].bus_reset_delay);
+	dprintk(1, "qla1280 : bus reset delay[1]=%d\n",
+		nv->bus[1].bus_reset_delay);
+
+	dprintk(1, "qla1280 : retry count[0]=%d\n", nv->bus[0].retry_count);
+	dprintk(1, "qla1280 : retry delay[0]=%d\n", nv->bus[0].retry_delay);
+	dprintk(1, "qla1280 : retry count[1]=%d\n", nv->bus[1].retry_count);
+	dprintk(1, "qla1280 : retry delay[1]=%d\n", nv->bus[1].retry_delay);
+
+	dprintk(1, "qla1280 : async data setup time[0]=%d\n",
+		nv->bus[0].config_2.async_data_setup_time);
+	dprintk(1, "qla1280 : async data setup time[1]=%d\n",
+		nv->bus[1].config_2.async_data_setup_time);
+
+	dprintk(1, "qla1280 : req/ack active negation[0]=%d\n",
+		nv->bus[0].config_2.req_ack_active_negation);
+	dprintk(1, "qla1280 : req/ack active negation[1]=%d\n",
+		nv->bus[1].config_2.req_ack_active_negation);
+
+	dprintk(1, "qla1280 : data line active negation[0]=%d\n",
+		nv->bus[0].config_2.data_line_active_negation);
+	dprintk(1, "qla1280 : data line active negation[1]=%d\n",
+		nv->bus[1].config_2.data_line_active_negation);
+
+	dprintk(1, "qla1280 : disable loading risc code=%d\n",
+		nv->cntr_flags_1.disable_loading_risc_code);
+
+	dprintk(1, "qla1280 : enable 64bit addressing=%d\n",
+		nv->cntr_flags_1.enable_64bit_addressing);
+
+	dprintk(1, "qla1280 : selection timeout limit[0]=%d\n",
+		nv->bus[0].selection_timeout);
+	dprintk(1, "qla1280 : selection timeout limit[1]=%d\n",
+		nv->bus[1].selection_timeout);
+
+	dprintk(1, "qla1280 : max queue depth[0]=%d\n",
+		nv->bus[0].max_queue_depth);
+	dprintk(1, "qla1280 : max queue depth[1]=%d\n",
+		nv->bus[1].max_queue_depth);
+
+	/* Disable RISC load of firmware. */
+	ha->flags.disable_risc_code_load =
+		nv->cntr_flags_1.disable_loading_risc_code;
+
+#ifdef QLA_64BIT_PTR
+	/* Enable 64bit addressing for OS/System combination supporting it   */
+	/* actual NVRAM bit is: nv->cntr_flags_1.enable_64bit_addressing     */
+	/* but we will ignore it and use BITS_PER_LONG macro to setup for    */
+	/* 64 or 32 bit access of host memory in all x86/ia-64/Alpha systems */
+	ha->flags.enable_64bit_addressing = 1;
 #else
-        DEBUG(printk("Using defaults for NVRAM: \n"));
-        DEBUG(printk("checksum=0x%x, Id=%c, version=0x%x\n",chksum,nv->id[0],nv->version));
-#if defined(QL_DEBUG_LEVEL_3)
-        /* ql_debug_print = 1;
-        qla1280_dump_buffer((caddr_t)ha->response_ring, REQUEST_ENTRY_SIZE);
-        ql_debug_print = 0; */
-#endif
-                wptr = (uint16_t *)ha->response_ring;
-        for (cnt = 0; cnt < sizeof(nvram_t)/2; cnt++)
-            *wptr++ = 0;
+	ha->flags.enable_64bit_addressing = 0;
 #endif
 
+	if (ha->flags.enable_64bit_addressing) {
+		dprintk(2, "scsi(%li): 64 Bit PCI Addressing Enabled\n",
+			ha->host_no);
 
-        /* nv->cntr_flags_1.disable_loading_risc_code = 1; */
-        nv->firmware_feature.w = BIT_0;
-        nv->termination.f.scsi_bus_0_control = 3;
-        nv->termination.f.scsi_bus_1_control = 3;
-        nv->termination.f.auto_term_support = 1;
-
-        for (b = 0; b < MAX_BUSES; b++)
-        {
-            nv->bus[b].config_1.initiator_id = 7;
-            nv->bus[b].bus_reset_delay = 5;
-            nv->bus[b].config_2.async_data_setup_time = 9;
-            nv->bus[b].config_2.req_ack_active_negation = 1;
-            nv->bus[b].config_2.data_line_active_negation = 1;
-            nv->bus[b].selection_timeout = 250;
-            nv->bus[b].max_queue_depth = 256;
-
-            for (t = 0; t < MAX_TARGETS; t++)
-            {
-                nv->bus[b].target[t].parameter.f.auto_request_sense = 1;
-                nv->bus[b].target[t].parameter.f.disconnect_allowed = 1;
-                nv->bus[b].target[t].parameter.f.tag_queuing = 1;
-                nv->bus[b].target[t].flags.device_enable = 1;
-            }
-        }
+		pci_set_dma_mask(ha->pdev, (dma_addr_t) ~ 0ULL);
+	}
 
-#if  USE_NVRAM_DEFAULTS
-        status = 0;
-#else
-        status = 1;
+	/* Set ISP hardware DMA burst */
+	mb[0] = nv->isp_config.c;
+	/* Enable DMA arbitration on dual channel controllers */
+	if (ha->ports > 1)
+		mb[0] |= BIT_13;
+	WRT_REG_WORD(&reg->cfg_1, mb[0]);
+
+#if 1	/* Is this safe? */
+	/* Set SCSI termination. */
+	WRT_REG_WORD(&reg->gpio_enable, (BIT_3 + BIT_2 + BIT_1 + BIT_0));
+	mb[0] = nv->termination.c & (BIT_3 + BIT_2 + BIT_1 + BIT_0);
+	WRT_REG_WORD(&reg->gpio_data, mb[0]);
+#endif
+
+	/* ISP parameter word. */
+	mb[0] = MBC_SET_SYSTEM_PARAMETER;
+	mb[1] = nv->isp_parameter;
+	status |= qla1280_mailbox_command(ha, BIT_1 | BIT_0, &mb[0]);
+
+#if 0
+	/* clock rate - for qla1240 and older, only */
+	mb[0] = MBC_SET_CLOCK_RATE;
+	mb[1] = 0x50;
+ 	status |= qla1280_mailbox_command(ha, BIT_1 | BIT_0, &mb[0]);
+#endif
+	/* Firmware feature word. */
+	mb[0] = MBC_SET_FIRMWARE_FEATURES;
+	mask = BIT_5 | BIT_1 | BIT_0;
+	mb[1] = le16_to_cpu(nv->firmware_feature.w) & (mask);
+#if defined(CONFIG_IA64_GENERIC) || defined (CONFIG_IA64_SGI_SN2)
+	if (ia64_platform_is("sn2")) {
+		printk(KERN_INFO "scsi(%li): Enabling SN2 PCI DMA "
+		       "workaround\n", ha->host_no);
+		mb[1] |= BIT_9;
+	}
 #endif
-    }
-    else
-    {
-        /* Always force AUTO sense for LINUX SCSI */
-        for (b = 0; b < MAX_BUSES; b++)
-            for (t = 0; t < MAX_TARGETS; t++)
-            {
-                nv->bus[b].target[t].parameter.f.auto_request_sense = 1;
-            }
-    }
-#if  DEBUG_PRINT_NVRAM
-    ql_debug_print = 1;
-    sprintf(debug_buff,"qla1280 : initiator scsi id bus[0]=%d\n\r",
-            nv->bus[0].config_1.initiator_id);
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"qla1280 : initiator scsi id bus[1]=%d\n\r",
-            nv->bus[1].config_1.initiator_id);
-    qla1280_print(debug_buff);
-
-    sprintf(debug_buff,"qla1280 : bus reset delay[0]=%d\n\r",
-            nv->bus[0].bus_reset_delay);
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"qla1280 : bus reset delay[1]=%d\n\r",
-            nv->bus[1].bus_reset_delay);
-    qla1280_print(debug_buff);
-
-    sprintf(debug_buff,"qla1280 : retry count[0]=%d\n\r",
-            nv->bus[0].retry_count);
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"qla1280 : retry delay[0]=%d\n\r",
-            nv->bus[0].retry_delay);
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"qla1280 : retry count[1]=%d\n\r",
-            nv->bus[1].retry_count);
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"qla1280 : retry delay[1]=%d\n\r",
-            nv->bus[1].retry_delay);
-    qla1280_print(debug_buff);
-
-    sprintf(debug_buff,"qla1280 : async data setup time[0]=%d\n\r",
-            nv->bus[0].config_2.async_data_setup_time);
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"qla1280 : async data setup time[1]=%d\n\r",
-            nv->bus[1].config_2.async_data_setup_time);
-    qla1280_print(debug_buff);
-
-    sprintf(debug_buff,"qla1280 : req/ack active negation[0]=%d\n\r",
-            nv->bus[0].config_2.req_ack_active_negation);
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"qla1280 : req/ack active negation[1]=%d\n\r",
-            nv->bus[1].config_2.req_ack_active_negation);
-    qla1280_print(debug_buff);
-
-    sprintf(debug_buff,"qla1280 : data line active negation[0]=%d\n\r",
-            nv->bus[0].config_2.data_line_active_negation);
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"qla1280 : data line active negation[1]=%d\n\r",
-            nv->bus[1].config_2.data_line_active_negation);
-    qla1280_print(debug_buff);
-
-
-    sprintf(debug_buff,"qla1280 : disable loading risc code=%d\n\r",
-            nv->cntr_flags_1.disable_loading_risc_code);
-    qla1280_print(debug_buff);
-
-    sprintf(debug_buff,"qla1280 : enable 64bit addressing=%d\n\r",
-            nv->cntr_flags_1.enable_64bit_addressing);
-    qla1280_print(debug_buff);
-
-    sprintf(debug_buff,"qla1280 : selection timeout limit[0]=%d\n\r",
-            nv->bus[0].selection_timeout);
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"qla1280 : selection timeout limit[1]=%d\n\r",
-            nv->bus[1].selection_timeout);
-
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"qla1280 : max queue depth[0]=%d\n\r",
-            nv->bus[0].max_queue_depth);
-    qla1280_print(debug_buff);
-    sprintf(debug_buff,"qla1280 : max queue depth[1]=%d\n\r",
-            nv->bus[1].max_queue_depth);
-    qla1280_print(debug_buff);
-#endif
-
-    DEBUG(ql_debug_print = 0;)
-
-    /* Disable RISC load of firmware. */
-    ha->flags.disable_risc_code_load =
-            nv->cntr_flags_1.disable_loading_risc_code;
-    /* Enable 64bit addressing. */
-    ha->flags.enable_64bit_addressing =
-            nv->cntr_flags_1.enable_64bit_addressing;
-
-    /* Set ISP hardware DMA burst */
-    mb[0] = nv->isp_config.c;
-    WRT_REG_WORD(&reg->cfg_1, mb[0]);
-
-    /* Set SCSI termination. */
-    WRT_REG_WORD(&reg->gpio_enable, (BIT_3 + BIT_2 + BIT_1 + BIT_0));
-    mb[0] = nv->termination.c & (BIT_3 + BIT_2 + BIT_1 + BIT_0);
-    WRT_REG_WORD(&reg->gpio_data, mb[0]);
-
-    /* ISP parameter word. */
-    mb[0] = MBC_SET_SYSTEM_PARAMETER;
-    mb[1] = nv->isp_parameter;
-    status |= qla1280_mailbox_command(ha, BIT_1|BIT_0, &mb[0]);
-
-    /* Firmware feature word. */
-    mb[0] = MBC_SET_FIRMWARE_FEATURES;
-    mb[1] = nv->firmware_feature.w & (BIT_1|BIT_0);
-    status |= qla1280_mailbox_command(ha, BIT_1|BIT_0, &mb[0]);
-
-    /* Retry count and delay. */
-    mb[0] = MBC_SET_RETRY_COUNT;
-    mb[1] = nv->bus[0].retry_count;
-    mb[2] = nv->bus[0].retry_delay;
-    mb[6] = nv->bus[1].retry_count;
-    mb[7] = nv->bus[1].retry_delay;
-    status |= qla1280_mailbox_command(ha, BIT_7|BIT_6|BIT_2|BIT_1|BIT_0, &mb[0]);
-
-    /* ASYNC data setup time. */
-    mb[0] = MBC_SET_ASYNC_DATA_SETUP;
-    mb[1] = nv->bus[0].config_2.async_data_setup_time;
-    mb[2] = nv->bus[1].config_2.async_data_setup_time;
-    status |= qla1280_mailbox_command(ha, BIT_2|BIT_1|BIT_0, &mb[0]);
-
-    /* Active negation states. */
-    mb[0] = MBC_SET_ACTIVE_NEGATION;
-    mb[1] = 0;
-    if (nv->bus[0].config_2.req_ack_active_negation)
-        mb[1] |= BIT_5;
-    if (nv->bus[0].config_2.data_line_active_negation)
-        mb[1] |= BIT_4;
-    mb[2] = 0;
-    if (nv->bus[1].config_2.req_ack_active_negation)
-        mb[2] |= BIT_5;
-    if (nv->bus[1].config_2.data_line_active_negation)
-        mb[2] |= BIT_4;
-    status |= qla1280_mailbox_command(ha, BIT_2|BIT_1|BIT_0, &mb[0]);
-
-    /* Selection timeout. */
-    mb[0] = MBC_SET_SELECTION_TIMEOUT;
-    mb[1] = nv->bus[0].selection_timeout;
-    mb[2] = nv->bus[1].selection_timeout;
-    status |= qla1280_mailbox_command(ha, BIT_2|BIT_1|BIT_0, &mb[0]);
-
-    for (b = 0; b < ha->ports; b++)
-    {
-        /* SCSI Reset Disable. */
-        ha->bus_settings[b].disable_scsi_reset = nv->bus[b].config_1.scsi_reset_disable;
-
-        /* Initiator ID. */
-        ha->bus_settings[b].id = nv->bus[b].config_1.initiator_id;
-        mb[0] = MBC_SET_INITIATOR_ID;
-        mb[1] = b ? ha->bus_settings[b].id | BIT_7 : ha->bus_settings[b].id;
-        status |= qla1280_mailbox_command(ha, BIT_1|BIT_0, &mb[0]);
-
-        /* Reset Delay. */
-        ha->bus_settings[b].bus_reset_delay = nv->bus[b].bus_reset_delay;
-
-        /* Command queue depth per device. */
-        ha->bus_settings[b].hiwat = nv->bus[b].max_queue_depth - 1;
-
-        /* Set target parameters. */
-        for (t = 0; t < MAX_TARGETS; t++)
-        {
-            if( ha->device_id == QLA12160_DEVICE_ID ||  
-                ha->device_id == QLA10160_DEVICE_ID )  
-            {
-                status = qla12160_set_target_parameters(ha,b,t,0,(nvram160_t *)nv);
-            }
+	status |= qla1280_mailbox_command(ha, mask, &mb[0]);
+
+	/* Retry count and delay. */
+	mb[0] = MBC_SET_RETRY_COUNT;
+	mb[1] = nv->bus[0].retry_count;
+	mb[2] = nv->bus[0].retry_delay;
+	mb[6] = nv->bus[1].retry_count;
+	mb[7] = nv->bus[1].retry_delay;
+	status |= qla1280_mailbox_command(ha, BIT_7 | BIT_6 | BIT_2 |
+					  BIT_1 | BIT_0, &mb[0]);
+
+	/* ASYNC data setup time. */
+	mb[0] = MBC_SET_ASYNC_DATA_SETUP;
+	mb[1] = nv->bus[0].config_2.async_data_setup_time;
+	mb[2] = nv->bus[1].config_2.async_data_setup_time;
+	status |= qla1280_mailbox_command(ha, BIT_2 | BIT_1 | BIT_0, &mb[0]);
+
+	/* Active negation states. */
+	mb[0] = MBC_SET_ACTIVE_NEGATION;
+	mb[1] = 0;
+	if (nv->bus[0].config_2.req_ack_active_negation)
+		mb[1] |= BIT_5;
+	if (nv->bus[0].config_2.data_line_active_negation)
+		mb[1] |= BIT_4;
+	mb[2] = 0;
+	if (nv->bus[1].config_2.req_ack_active_negation)
+		mb[2] |= BIT_5;
+	if (nv->bus[1].config_2.data_line_active_negation)
+		mb[2] |= BIT_4;
+	status |= qla1280_mailbox_command(ha, BIT_2 | BIT_1 | BIT_0, &mb[0]);
+
+	mb[0] = MBC_SET_DATA_OVERRUN_RECOVERY;
+	mb[1] = 2;	/* Reset SCSI bus and return all outstanding IO */
+	status |= qla1280_mailbox_command(ha, BIT_1 | BIT_0, &mb[0]);
+
+	/* thingy */
+	mb[0] = MBC_SET_PCI_CONTROL;
+	mb[1] = 2;	/* Data DMA Channel Burst Enable */
+	mb[2] = 2;	/* Command DMA Channel Burst Enable */
+	status |= qla1280_mailbox_command(ha, BIT_2 | BIT_1 | BIT_0, &mb[0]);
+
+	/* Selection timeout. */
+	mb[0] = MBC_SET_SELECTION_TIMEOUT;
+	mb[1] = nv->bus[0].selection_timeout;
+	mb[2] = nv->bus[1].selection_timeout;
+	status |= qla1280_mailbox_command(ha, BIT_2 | BIT_1 | BIT_0, &mb[0]);
+
+	for (bus = 0; bus < ha->ports; bus++) {
+		/* SCSI Reset Disable. */
+		ha->bus_settings[bus].disable_scsi_reset =
+			nv->bus[bus].config_1.scsi_reset_disable;
+
+		/* Initiator ID. */
+		ha->bus_settings[bus].id = nv->bus[bus].config_1.initiator_id;
+		mb[0] = MBC_SET_INITIATOR_ID;
+		mb[1] = bus ? ha->bus_settings[bus].id | BIT_7 :
+			ha->bus_settings[bus].id;
+		status |= qla1280_mailbox_command(ha, BIT_1 | BIT_0, &mb[0]);
+
+		/* Reset Delay. */
+		ha->bus_settings[bus].bus_reset_delay =
+			nv->bus[bus].bus_reset_delay;
+
+		/* Command queue depth per device. */
+		ha->bus_settings[bus].hiwat = nv->bus[bus].max_queue_depth - 1;
+
+		/* Set target parameters. */
+		for (target = 0; target < MAX_TARGETS; target++) {
+			uint8_t mr = BIT_2 | BIT_1 | BIT_0;
+
+			/* Set Target Parameters. */
+			mb[0] = MBC_SET_TARGET_PARAMETERS;
+			mb[1] = (uint16_t) (bus ? target | BIT_7 : target);
+			mb[1] <<= 8;
+			/*
+			 * Do not enable wide, sync, and ppr for the initial
+			 * INQUIRY run. We enable this later if we determine
+			 * the target actually supports it.
+			 */
+			nv->bus[bus].target[target].parameter.f.
+				auto_request_sense = 1;
+			nv->bus[bus].target[target].parameter.f.
+				stop_queue_on_check = 0;
+
+			if (is1x160)
+				nv->bus[bus].target[target].ppr_1x160.
+					flags.enable_ppr = 0;
+			/*
+			 * No sync, wide, etc. while probing
+			 */
+			mb[2] = (nv->bus[bus].target[target].parameter.c << 8)&
+				~(TP_SYNC /*| TP_WIDE | TP_PPR*/);
+
+			if (is1x160)
+				mb[3] =	nv->bus[bus].target[target].flags.flags1x160.sync_offset << 8;
 			else
-            {
-                /* Set Target Parameters. */
-                mb[0] = MBC_SET_TARGET_PARAMETERS;
-                mb[1] = (uint16_t)(b ? t | BIT_7 :t);
-                mb[1] <<= 8;
-                mb[2] = nv->bus[b].target[t].parameter.c << 8;
-                mb[2] |= TP_AUTO_REQUEST_SENSE;
-                mb[2] &= ~TP_STOP_QUEUE;
-                mb[3] = nv->bus[b].target[t].flags.sync_offset << 8;
-                mb[3] |= nv->bus[b].target[t].sync_period;
-                status |= qla1280_mailbox_command(ha, BIT_3|BIT_2|BIT_1|BIT_0,
-                    &mb[0]);
-            }
-
-            /* Save Tag queuing enable flag. */
-            mb[0] = BIT_0 << t;
-            if (nv->bus[b].target[t].parameter.f.tag_queuing)
-                ha->bus_settings[b].qtag_enables |= mb[0];
-
-            /* Save Device enable flag. */
-            if (nv->bus[b].target[t].flags.device_enable)
-                ha->bus_settings[b].device_enables |= mb[0];
-
-            /* Save LUN disable flag. */
-            if (nv->bus[b].target[t].flags.lun_disable)
-                ha->bus_settings[b].lun_disables |= mb[0];
-
-            /* Set Device Queue Parameters. */
-            for (l = 0; l < MAX_LUNS; l++)
-            {
-                mb[0] = MBC_SET_DEVICE_QUEUE;
-                mb[1] = (uint16_t)(b ? t | BIT_7 :t);
-                mb[1] = mb[1] << 8 | l;
-                mb[2] = nv->bus[b].max_queue_depth;
-                mb[3] = nv->bus[b].target[t].execution_throttle;
-                status |= qla1280_mailbox_command(ha, BIT_3|BIT_2|BIT_1|BIT_0,
-                        &mb[0]);
-            }
-        }
-    }
-    DEBUG(ql_debug_print = 0;)
-
-#if defined(QL_DEBUG_ROUTINES) && !defined(QL_DEBUG_LEVEL_4)
-    ql_debug_print = saved_print_status;
-#endif
-
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    DEBUG(if (status))
-        DEBUG(qla1280_print("qla1280_nvram_config: **** FAILED ****\n\r");)
-#endif
-    LEAVE("qla1280_nvram_config");
-    return(status);
+				mb[3] =	nv->bus[bus].target[target].flags.flags1x80.sync_offset << 8;
+			mb[3] |= nv->bus[bus].target[target].sync_period;
+			mr |= BIT_3;
+
+			/*
+			 * We don't want to enable ppr etc. before we have 
+			 * determined that the target actually supports it
+			 */
+#if 0
+			if (is1x160) {
+				mb[2] |= nv->bus[bus].target[target].ppr_1x160.flags.enable_ppr << 5;
+
+				mb[6] =	nv->bus[bus].target[target].ppr_1x160.flags.ppr_options << 8;
+				mb[6] |= nv->bus[bus].target[target].ppr_1x160.flags.ppr_bus_width;
+				mr |= BIT_6;
+			}
+#endif
+
+			status = qla1280_mailbox_command(ha, mr, &mb[0]);
+
+			/* Save Tag queuing enable flag. */
+			mb[0] = BIT_0 << target;
+			if (nv->bus[bus].target[target].parameter.f.tag_queuing)
+				ha->bus_settings[bus].qtag_enables |= mb[0];
+
+			/* Save Device enable flag. */
+			if (is1x160) {
+				if (nv->bus[bus].target[target].flags.flags1x160.device_enable)
+					ha->bus_settings[bus].device_enables |= mb[0];
+				ha->bus_settings[bus].lun_disables |= 0;
+			} else {
+				if (nv->bus[bus].target[target].flags.flags1x80.device_enable)
+					ha->bus_settings[bus].device_enables |= mb[0];
+				/* Save LUN disable flag. */
+				if (nv->bus[bus].target[target].flags.flags1x80.lun_disable)
+				ha->bus_settings[bus].lun_disables |= mb[0];
+			}
+
+
+			/* Set Device Queue Parameters. */
+			for (lun = 0; lun < MAX_LUNS; lun++) {
+				mb[0] = MBC_SET_DEVICE_QUEUE;
+				mb[1] = (uint16_t)(bus ? target | BIT_7 : target);
+				mb[1] = mb[1] << 8 | lun;
+				mb[2] = nv->bus[bus].max_queue_depth;
+				mb[3] = nv->bus[bus].target[target].execution_throttle;
+				status |= qla1280_mailbox_command(ha, 0x0f,
+								  &mb[0]);
+			}
+		}
+	}
+
+	if (status)
+		dprintk(2, "qla1280_nvram_config: **** FAILED ****\n");
+
+	LEAVE("qla1280_nvram_config");
+	return status;
 }
 
 /*
@@ -3307,36 +3078,21 @@
  * Returns:
  *      data word.
  */
-STATIC uint16_t
-qla1280_get_nvram_word(scsi_qla_host_t *ha, uint32_t address)
+static uint16_t
+qla1280_get_nvram_word(struct scsi_qla_host *ha, uint32_t address)
 {
-    uint32_t nv_cmd;
-    uint16_t data;
+	uint32_t nv_cmd;
+	uint16_t data;
 
-#ifdef QL_DEBUG_ROUTINES
-    uint8_t  saved_print_status = ql_debug_print;
-#endif
-#ifdef QL_DEBUG_LEVEL_4
-    ENTER("qla1280_get_nvram_word");
-#endif
+	nv_cmd = address << 16;
+	nv_cmd |= NV_READ_OP;
 
-    nv_cmd = address << 16;
-    nv_cmd |= NV_READ_OP;
+	data = le16_to_cpu(qla1280_nvram_request(ha, nv_cmd));
 
-#ifdef QL_DEBUG_ROUTINES
-    ql_debug_print = FALSE;
-#endif
-    data = qla1280_nvram_request(ha, nv_cmd);
-#ifdef QL_DEBUG_ROUTINES
-    ql_debug_print = saved_print_status;
-#endif
+	dprintk(8, "qla1280_get_nvram_word: exiting normally NVRAM data = "
+		"0x%x", data);
 
-#ifdef QL_DEBUG_LEVEL_4
-    qla1280_print("qla1280_get_nvram_word: exiting normally NVRAM data = ");
-    qla1280_output_number((uint32_t)data, 16);
-    qla1280_print("\n\r");
-#endif
-    return(data);
+	return data;
 }
 
 /*
@@ -3353,76 +3109,63 @@
  * Returns:
  *      data word.
  */
-STATIC uint16_t
-qla1280_nvram_request(scsi_qla_host_t *ha, uint32_t nv_cmd)
+static uint16_t
+qla1280_nvram_request(struct scsi_qla_host *ha, uint32_t nv_cmd)
+{
+	struct device_reg *reg = ha->iobase;
+	int cnt;
+	uint16_t data = 0;
+	uint16_t reg_data;
+
+	/* Send command to NVRAM. */
+
+	nv_cmd <<= 5;
+	for (cnt = 0; cnt < 11; cnt++) {
+		if (nv_cmd & BIT_31)
+			qla1280_nv_write(ha, NV_DATA_OUT);
+		else
+			qla1280_nv_write(ha, 0);
+		nv_cmd <<= 1;
+	}
+
+	/* Read data from NVRAM. */
+
+	for (cnt = 0; cnt < 16; cnt++) {
+		WRT_REG_WORD(&reg->nvram, (NV_SELECT | NV_CLOCK));
+		RD_REG_WORD(&reg->id_l);	/* Flush PCI write */
+		NVRAM_DELAY();
+		data <<= 1;
+		reg_data = RD_REG_WORD(&reg->nvram);
+		if (reg_data & NV_DATA_IN)
+			data |= BIT_0;
+		WRT_REG_WORD(&reg->nvram, NV_SELECT);
+		RD_REG_WORD(&reg->id_l);	/* Flush PCI write */
+		NVRAM_DELAY();
+	}
+
+	/* Deselect chip. */
+
+	WRT_REG_WORD(&reg->nvram, NV_DESELECT);
+	RD_REG_WORD(&reg->id_l);	/* Flush PCI write */
+	NVRAM_DELAY();
+
+	return data;
+}
+
+static void
+qla1280_nv_write(struct scsi_qla_host *ha, uint16_t data)
 {
-    uint8_t      cnt;
-    device_reg_t *reg = ha->iobase;
-    uint16_t     data = 0;
-    uint16_t     reg_data;
-
-    /* Send command to NVRAM. */
-
-    nv_cmd <<= 5;
-    for (cnt = 0; cnt < 11; cnt++)
-    {
-        if (nv_cmd & BIT_31)
-            qla1280_nv_write(ha, NV_DATA_OUT);
-        else
-            qla1280_nv_write(ha, 0);
-        nv_cmd <<= 1;
-    }
-
-    /* Read data from NVRAM. */
-
-    for (cnt = 0; cnt < 16; cnt++)
-    {
-        WRT_REG_WORD(&reg->nvram, NV_SELECT+NV_CLOCK);
-        /* qla1280_nv_delay(ha); */
-        NVRAM_DELAY();
-        data <<= 1;
-        reg_data = RD_REG_WORD(&reg->nvram);
-        if (reg_data & NV_DATA_IN)
-            data |= BIT_0;
-        WRT_REG_WORD(&reg->nvram, NV_SELECT);
-        /* qla1280_nv_delay(ha); */
-        NVRAM_DELAY();
-    }
-
-    /* Deselect chip. */
-
-    WRT_REG_WORD(&reg->nvram, NV_DESELECT);
-    /* qla1280_nv_delay(ha); */
-    NVRAM_DELAY();
-
-    return(data);
-}
-
-STATIC void
-qla1280_nv_write(scsi_qla_host_t *ha, uint16_t data)
-{
-    device_reg_t *reg = ha->iobase;
-
-    WRT_REG_WORD(&reg->nvram, data | NV_SELECT);
-    NVRAM_DELAY();
-    /* qla1280_nv_delay(ha); */
-    WRT_REG_WORD(&reg->nvram, data | NV_SELECT | NV_CLOCK);
-    /* qla1280_nv_delay(ha); */
-    NVRAM_DELAY();
-    WRT_REG_WORD(&reg->nvram, data | NV_SELECT);
-    /* qla1280_nv_delay(ha); */
-    NVRAM_DELAY();
-}
-
-STATIC void
-qla1280_nv_delay(scsi_qla_host_t *ha)
-{
-    device_reg_t *reg = ha->iobase;
-    int          cnt  = NV_DELAY_COUNT;
-    uint16_t     data = 0;
+	struct device_reg *reg = ha->iobase;
 
-    while (cnt--)
-        data |= RD_REG_WORD(&reg->nvram);
+	WRT_REG_WORD(&reg->nvram, data | NV_SELECT);
+	RD_REG_WORD(&reg->id_l);	/* Flush PCI write */
+	NVRAM_DELAY();
+	WRT_REG_WORD(&reg->nvram, data | NV_SELECT | NV_CLOCK);
+	RD_REG_WORD(&reg->id_l);	/* Flush PCI write */
+	NVRAM_DELAY();
+	WRT_REG_WORD(&reg->nvram, data | NV_SELECT);
+	RD_REG_WORD(&reg->id_l);	/* Flush PCI write */
+	NVRAM_DELAY();
 }
 
 /*
